%Amplifier
clear all
close all
clc

load amplifier;
N = length(x);

%A sorted x vector over [0;2]
x_eval = linspace(0,2,N);

%output
figure
%Plot input/output samples of nonlinearity
plot(x,y, 'bx', 'MarkerSize', 6)
hold on, grid on
%45-degree line (ideal linearity)
plot(x_eval, x_eval, 'k--','linewidth',2)

xlabel('x[n]')
ylabel('y = f(x[n])')

%original Q2-value (Deviation from linearity)
Q2_orig = q(x, y)

%----------------------------
%Forward-fit with polyfit
%help polyfit
M = 2;    %Polynomial order   % use M = 75 to show how it divergea
poly = polyfit(x,y, M);
%Evaluate polynomial model over x_eval to be able to plot a nice line
f_poly = polyval(poly, x_eval);

plot(x_eval, f_poly, 'r--' ,'linewidth',3)
legend('measured NL', 'Ideal linearity','Polynomial fit','Location', 'NorthWest')

%-----------------------------
%Fit-an-inverse with polyfit
poly_inv = polyfit(y, x, M);
%post-distort (evaluate on NL output)
z = polyval(poly_inv, y);

%linearized Q2 value
Q2_post_distort = q(x, z)

%plot the linearized samples (again over original x, to get the values at the 'measured' values
plot(x, z, 'rx', 'MarkerSize', 6)

legend('measured NL', 'Ideal linearity', 'Polynomial fit','Post-distorted','Location', 'NorthWest')



